#include <hxcpp.h>

#ifndef INCLUDED_snow_platform_native_input_sdl_KeyEventType
#include <snow/platform/native/input/sdl/KeyEventType.h>
#endif
namespace snow{
namespace platform{
namespace native{
namespace input{
namespace sdl{

::snow::platform::native::input::sdl::KeyEventType KeyEventType_obj::down;

::snow::platform::native::input::sdl::KeyEventType KeyEventType_obj::textedit;

::snow::platform::native::input::sdl::KeyEventType KeyEventType_obj::textinput;

::snow::platform::native::input::sdl::KeyEventType KeyEventType_obj::unknown;

::snow::platform::native::input::sdl::KeyEventType KeyEventType_obj::up;

HX_DEFINE_CREATE_ENUM(KeyEventType_obj)

int KeyEventType_obj::__FindIndex(::String inName)
{
	if (inName==HX_CSTRING("down")) return 1;
	if (inName==HX_CSTRING("textedit")) return 3;
	if (inName==HX_CSTRING("textinput")) return 4;
	if (inName==HX_CSTRING("unknown")) return 0;
	if (inName==HX_CSTRING("up")) return 2;
	return super::__FindIndex(inName);
}

int KeyEventType_obj::__FindArgCount(::String inName)
{
	if (inName==HX_CSTRING("down")) return 0;
	if (inName==HX_CSTRING("textedit")) return 0;
	if (inName==HX_CSTRING("textinput")) return 0;
	if (inName==HX_CSTRING("unknown")) return 0;
	if (inName==HX_CSTRING("up")) return 0;
	return super::__FindArgCount(inName);
}

Dynamic KeyEventType_obj::__Field(const ::String &inName,bool inCallProp)
{
	if (inName==HX_CSTRING("down")) return down;
	if (inName==HX_CSTRING("textedit")) return textedit;
	if (inName==HX_CSTRING("textinput")) return textinput;
	if (inName==HX_CSTRING("unknown")) return unknown;
	if (inName==HX_CSTRING("up")) return up;
	return super::__Field(inName,inCallProp);
}

static ::String sStaticFields[] = {
	HX_CSTRING("unknown"),
	HX_CSTRING("down"),
	HX_CSTRING("up"),
	HX_CSTRING("textedit"),
	HX_CSTRING("textinput"),
	::String(null()) };

static void sMarkStatics(HX_MARK_PARAMS) {
	HX_MARK_MEMBER_NAME(KeyEventType_obj::down,"down");
	HX_MARK_MEMBER_NAME(KeyEventType_obj::textedit,"textedit");
	HX_MARK_MEMBER_NAME(KeyEventType_obj::textinput,"textinput");
	HX_MARK_MEMBER_NAME(KeyEventType_obj::unknown,"unknown");
	HX_MARK_MEMBER_NAME(KeyEventType_obj::up,"up");
};

#ifdef HXCPP_VISIT_ALLOCS
static void sVisitStatic(HX_VISIT_PARAMS) {
	HX_VISIT_MEMBER_NAME(KeyEventType_obj::__mClass,"__mClass");
	HX_VISIT_MEMBER_NAME(KeyEventType_obj::down,"down");
	HX_VISIT_MEMBER_NAME(KeyEventType_obj::textedit,"textedit");
	HX_VISIT_MEMBER_NAME(KeyEventType_obj::textinput,"textinput");
	HX_VISIT_MEMBER_NAME(KeyEventType_obj::unknown,"unknown");
	HX_VISIT_MEMBER_NAME(KeyEventType_obj::up,"up");
};
#endif

static ::String sMemberFields[] = { ::String(null()) };
Class KeyEventType_obj::__mClass;

Dynamic __Create_KeyEventType_obj() { return new KeyEventType_obj; }

void KeyEventType_obj::__register()
{

hx::Static(__mClass) = hx::RegisterClass(HX_CSTRING("snow.platform.native.input.sdl.KeyEventType"), hx::TCanCast< KeyEventType_obj >,sStaticFields,sMemberFields,
	&__Create_KeyEventType_obj, &__Create,
	&super::__SGetClass(), &CreateKeyEventType_obj, sMarkStatics
#ifdef HXCPP_VISIT_ALLOCS
    , sVisitStatic
#endif
#ifdef HXCPP_SCRIPTABLE
    , 0
#endif
);
}

void KeyEventType_obj::__boot()
{
hx::Static(down) = hx::CreateEnum< KeyEventType_obj >(HX_CSTRING("down"),1);
hx::Static(textedit) = hx::CreateEnum< KeyEventType_obj >(HX_CSTRING("textedit"),3);
hx::Static(textinput) = hx::CreateEnum< KeyEventType_obj >(HX_CSTRING("textinput"),4);
hx::Static(unknown) = hx::CreateEnum< KeyEventType_obj >(HX_CSTRING("unknown"),0);
hx::Static(up) = hx::CreateEnum< KeyEventType_obj >(HX_CSTRING("up"),2);
}


} // end namespace snow
} // end namespace platform
} // end namespace native
} // end namespace input
} // end namespace sdl
